%% Calculate matrix E
function E = CalculateE(Kv,Kt,Ms,Js,Ku,Kuh,Dlat,N,w)
E = zeros(2*N+2, 2*N+2);
E(1:N,1:N) = -1/(w^2*Ms);
E(N+1,N+1) = -1/(w^2*Ms)+1/Kv;
E(N+2,N+2) = -1/(w^2*Js)+1/Kt;
for iN = 1: 1: N
    for jN = 1: 1: N
        E(iN,jN) = E(iN,jN) - Dlat^2/(w^2*Js)*(iN-1-(N-1)/2)*(jN-1-(N-1)/2);
    end
    E(iN,iN) = E(iN,iN) + 1/Ku;
    E(N+2+iN,N+2+iN) = 1/Kuh;
    E(iN,N+(1:2)) = [1/(w^2*Ms) (iN-1-(N-1)/2)*Dlat/(w^2*Js)];
    E(N+(1:2),iN) = [1/(w^2*Ms) (iN-1-(N-1)/2)*Dlat/(w^2*Js)]';
end
end